globals
[
price-a-energy
price-b-energy
price-c-energy
price-d-energy
price-e-energy
price-f-energy

info-a-smart
info-b-smart
info-c-smart
info-d-smart
info-e-smart
info-f-smart

N    ;; the number of patches in the virtual community
i    ;; the number of time steps

count-smart
count-a
count-b
count-c
count-d
count-e
count-f
count-change
k
h
]

turtles-own
[
enthusiasm-s
p-s            ;; the degree to which an REC agent is sensitive to price
affectability  ;; the degree to which an REC agent is sensitive to other REC agents 
intention-a-t
intention-a-s
intention-b-t
intention-b-s
intention-c-t
intention-c-s
intention-d-t
intention-d-s
intention-e-t
intention-e-s
intention-f-t
intention-f-s


influence-out-sa
influence-out-ta
influence-out-sb
influence-out-tb
influence-out-sc
influence-out-tc
influence-out-sd
influence-out-td
influence-out-se
influence-out-te
influence-out-sf
influence-out-tf


influence-in-sa
influence-in-ta
influence-in-sb
influence-in-tb
influence-in-sc
influence-in-tc
influence-in-sd
influence-in-td
influence-in-se
influence-in-te
influence-in-sf
influence-in-tf


taken?
a?
b?
c?
d?
e?
f?
change?


smart-meter?
max-intention
]

to setup
ca
set N count patches
set price-a-energy (80 + 20 * (random 10 / 10))
set price-a-energy (80 + 20 * (random 10 / 10))
set price-a-energy (80 + 20 * (random 10 / 10))
set price-a-energy (80 + 20 * (random 10 / 10))
set price-a-energy (80 + 20 * (random 10 / 10))
set price-a-energy (80 + 20 * (random 10 / 10))

set info-a-smart price-a-energy / 10
set info-b-smart price-b-energy / 10
set info-c-smart price-c-energy / 10
set info-d-smart price-d-energy / 10
set info-e-smart price-e-energy / 10
set info-f-smart price-f-energy / 10


ask n-of (population-density * N) patches
   [sprout 1 [set shape "house" set color blue]]
ask turtles [
  set taken? false
  set a? false
  set b? false
  set c? false
  set d? false
  set e? false
  set f? false
  
  set smart-meter? false
  set i 0
  set p-s (random 100) / (-100)
  ]

setup-RC
end

to setup-RC

ask n-of (0.21 * population-density * N) turtles [
         if (taken? = false)
          [set a? true 
           set taken? true]
          ]

ask n-of (0.19 * population-density * N) turtles [
         if (taken? = false)
          [set b? true
           set taken? true]
           ]

ask n-of (0.18 * population-density * N) turtles [
         if (taken? = false)
          [set c? true
           set taken? true]
           ]

ask n-of (0.16 * population-density * N) turtles [
         if (taken? = false)
          [set d? true
           set taken? true]
           ]
           
ask n-of (0.14 * population-density * N) turtles [
         if (taken? = false)
          [set e? true
           set taken? true]
           ]  
           
ask n-of (0.12 * population-density * N) turtles [
         if (taken? = false)
          [set f? true
           set taken? true]
           ]       



ask turtles [
          if (taken? = true)
             [set color blue]
            ]

ask turtles [
          set enthusiasm-s (random 100) / 100
          set affectability (random 100) / 100
            ]
If (scenario = 1)            
    [ask turtles with [enthusiasm-s >= 0.95]
       [set smart-meter? true 
        set color yellow]
    ]

If (scenario = 2)            
    [ask turtles with [enthusiasm-s >= 0.96]
       [set smart-meter? true 
        set color yellow]
    ]

If (scenario = 3)            
    [ask turtles with [enthusiasm-s >= 0.98]
       [set smart-meter? true 
        set color yellow]
    ]

If (scenario = 4)            
    [ask turtles with [enthusiasm-s >= 0.965]
       [set smart-meter? true 
        set color yellow]
    ]
  
     
ask turtles [
    if (smart-meter? = true and a? = true)
       [ set influence-out-sa 100
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
            
ask turtles [
    if (smart-meter? = true and b? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 100
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
       
ask turtles [
    if (smart-meter? = true and c? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 100
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]

ask turtles [
    if (smart-meter? = true and d? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 100
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ] 
            
ask turtles [
    if (smart-meter? = true and e? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 100
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
            
ask turtles [
    if (smart-meter? = true and f? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 100
         set influence-out-tf 0
         ;set influence-out-sg 0
         ;set influence-out-tg 0
       ]
            ] 
                       

ask turtles [
    if (smart-meter? = false and a? = true)
       [ set influence-out-sa 0
         set influence-out-ta random 100
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
            
ask turtles [
    if (smart-meter? = false and b? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb random 100
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
         
ask turtles [
    if (smart-meter? = false and c? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc random 100
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
            
ask turtles [
    if (smart-meter? = false and d? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td random 100
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]
            
ask turtles [
    if (smart-meter? = false and e? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te random 100
         set influence-out-sf 0
         set influence-out-tf 0
       ]
            ]

ask turtles [
    if (smart-meter? = false and f? = true)
       [ set influence-out-sa 0
         set influence-out-ta 0
         set influence-out-sb 0
         set influence-out-tb 0
         set influence-out-sc 0
         set influence-out-tc 0
         set influence-out-sd 0
         set influence-out-td 0
         set influence-out-se 0
         set influence-out-te 0
         set influence-out-sf 0
         set influence-out-tf random 100
       ]
            ]
     
end


to go
do-plot
set i i + 1
smart-meter
set k 1 - ((random 10) / 100) * 0 ^ (i mod 3)
set price-a-energy price-a-energy * (1 - ((random 10) / 100) * 0 ^ (i mod 3))
set price-b-energy price-b-energy * (1 - ((random 10) / 100) * 0 ^ (i mod 3))
set price-c-energy price-c-energy * (1 - ((random 10) / 100) * 0 ^ (i mod 3))
set price-d-energy price-d-energy * (1 - ((random 10) / 100) * 0 ^ (i mod 3))
set price-e-energy price-e-energy * (1 - ((random 10) / 100) * 0 ^ (i mod 3))
set price-f-energy price-f-energy * (1 - ((random 10) / 100) * 0 ^ (i mod 3))
set h  1 - (random 10) / 100
set info-a-smart price-a-energy * (1 - (random 10) / 100)
set info-b-smart price-b-energy * (1 - (random 10) / 100)
set info-c-smart price-c-energy * (1 - (random 10) / 100)
set info-d-smart price-d-energy * (1 - (random 10) / 100)
set info-e-smart price-e-energy * (1 - (random 10) / 100)
set info-f-smart price-f-energy * (1 - (random 10) / 100)
if (i = 25)
   [stop]
end


to smart-meter
ask turtles [
    set influence-in-ta sum [influence-out-ta] of (turtles in-radius radius)
    set influence-in-sa sum [influence-out-sa] of (turtles in-radius radius)
    set influence-in-tb sum [influence-out-tb] of (turtles in-radius radius)
    set influence-in-sb sum [influence-out-sb] of (turtles in-radius radius)
    set influence-in-tc sum [influence-out-tc] of (turtles in-radius radius)
    set influence-in-sc sum [influence-out-sc] of (turtles in-radius radius)
    set influence-in-td sum [influence-out-td] of (turtles in-radius radius)
    set influence-in-sd sum [influence-out-sd] of (turtles in-radius radius)
    set influence-in-te sum [influence-out-te] of (turtles in-radius radius)
    set influence-in-se sum [influence-out-se] of (turtles in-radius radius)
    set influence-in-tf sum [influence-out-tf] of (turtles in-radius radius)
    set influence-in-sf sum [influence-out-sf] of (turtles in-radius radius)
    
    
    let random-ta sum [influence-out-ta] of (n-of random random-interaction turtles)
    let random-sa sum [influence-out-sa] of (n-of random random-interaction turtles)
    let random-tb sum [influence-out-tb] of (n-of random random-interaction turtles)
    let random-sb sum [influence-out-sb] of (n-of random random-interaction turtles)
    let random-tc sum [influence-out-tc] of (n-of random random-interaction turtles)
    let random-sc sum [influence-out-sc] of (n-of random random-interaction turtles)
    let random-td sum [influence-out-td] of (n-of random random-interaction turtles)
    let random-sd sum [influence-out-sd] of (n-of random random-interaction turtles)
    let random-te sum [influence-out-te] of (n-of random random-interaction turtles)
    let random-se sum [influence-out-se] of (n-of random random-interaction turtles)
    let random-tf sum [influence-out-tf] of (n-of random random-interaction turtles)
    let random-sf sum [influence-out-sf] of (n-of random random-interaction turtles)
    
    
    set intention-a-t affectability * (influence-in-ta + random-ta) + p-s * (price-a-energy)
    set intention-a-s affectability * (influence-in-sa + random-sa) + p-s * (price-a-energy + info-a-smart)
    set intention-b-t affectability * (influence-in-tb + random-tb) + p-s * (price-b-energy)
    set intention-b-s affectability * (influence-in-sb + random-sb) + p-s * (price-b-energy + info-b-smart)
    set intention-c-t affectability * (influence-in-tc + random-tc) + p-s * (price-c-energy)
    set intention-c-s affectability * (influence-in-sc + random-sc) + p-s * (price-c-energy + info-c-smart)
    set intention-d-t affectability * (influence-in-td + random-td) + p-s * (price-d-energy)
    set intention-d-s affectability * (influence-in-sd + random-sd) + p-s * (price-d-energy + info-d-smart)
    set intention-e-t affectability * (influence-in-te + random-te) + p-s * (price-e-energy)
    set intention-e-s affectability * (influence-in-se + random-se) + p-s * (price-e-energy + info-e-smart)
    set intention-f-t affectability * (influence-in-tf + random-tf) + p-s * (price-f-energy)
    set intention-f-s affectability * (influence-in-sf + random-sf) + p-s * (price-f-energy + info-f-smart)
    
    ]

ask turtles [
    set change? false
    set max-intention intention-a-t
    if (max-intention <= intention-a-s)
       [set max-intention intention-a-s]
    if (max-intention <= intention-b-t)
       [set max-intention intention-b-t]
    if (max-intention <= intention-b-s)
       [set max-intention intention-b-s]
    if (max-intention <= intention-c-t)
       [set max-intention intention-c-t]
    if (max-intention <= intention-c-s)
       [set max-intention intention-c-s]
    if (max-intention <= intention-d-t)
       [set max-intention intention-d-t]       
    if (max-intention <= intention-d-s)
       [set max-intention intention-d-s]
    if (max-intention <= intention-e-t)
       [set max-intention intention-e-t]
    if (max-intention <= intention-e-s)
       [set max-intention intention-e-s] 
    if (max-intention <= intention-f-t)
       [set max-intention intention-f-t] 
    if (max-intention <= intention-f-s)
       [set max-intention intention-f-s]     
       ]
       
ask turtles with [a? = true]
      [
       if (max-intention != intention-a-t and max-intention != intention-a-s)
         [set change? true]
      ] 
       
ask turtles with [b? = true]
      [
       if (max-intention != intention-b-t and max-intention != intention-b-s)
         [set change? true]
      ]  
      
ask turtles with [c? = true]
      [
       if (max-intention != intention-c-t and max-intention != intention-c-s)
         [set change? true]
      ]  

ask turtles with [d? = true]
      [
       if (max-intention != intention-d-t and max-intention != intention-d-s)
         [set change? true]
      ]        
 
ask turtles with [e? = true]
      [
       if (max-intention != intention-e-t and max-intention != intention-e-s)
         [set change? true]
      ]
      
ask turtles with [f? = true]
      [
       if (max-intention != intention-f-t and max-intention != intention-f-s)
         [set change? true]
      ]
                      
ask turtles [
   if (color = blue)
    [
    if (max-intention = intention-a-t)
       [set influence-out-ta random 100
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0
        
        set a? true
        set b? false
        set c? false
        set d? false
        set e? false
        set f? false
        set smart-meter? false
        ] 
        
    if (max-intention = intention-a-s)
       [set influence-out-ta 0
        set influence-out-sa 100
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0
        
        set a? true
        set b? false
        set c? false
        set d? false
        set e? false
        set f? false
        set smart-meter? true
        ]
    
    if (max-intention = intention-b-t)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb random 100
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? true
        set c? false
        set d? false
        set e? false
        set f? false
        set smart-meter? false
        ]
        
    if (max-intention = intention-b-s)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 100
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? true
        set c? false
        set d? false
        set e? false
        set f? false
        set smart-meter? true
        ]
    
    if (max-intention = intention-c-t)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc random 100
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? false
        set c? true
        set d? false
        set e? false
        set f? false
        set smart-meter? false
        ] 
    
    if (max-intention = intention-c-s)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 100
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? false
        set c? true
        set d? false
        set e? false
        set f? false
        set smart-meter? true
        ]     
    
    if (max-intention = intention-d-t)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td random 100
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? false
        set c? false
        set d? true
        set e? false
        set f? false
        set smart-meter? false
        ]
    
    if (max-intention = intention-d-s)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 100
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? false
        set c? false
        set d? true
        set e? false
        set f? false
        set smart-meter? true
        ]  
        
    if (max-intention = intention-e-t)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te random 100
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? false
        set c? false
        set d? false
        set e? true
        set f? false
        set smart-meter? false
        ]              
   
   if (max-intention = intention-e-s)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 100
        set influence-out-tf 0
        set influence-out-sf 0

        set a? false
        set b? false
        set c? false
        set d? false
        set e? true
        set f? false
        set smart-meter? true
        ]             
   
   if (max-intention = intention-f-t)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf random 100
        set influence-out-sf 0

        set a? false
        set b? false
        set c? false
        set d? false
        set e? false
        set f? true
        set smart-meter? false
        ]             
  
   if (max-intention = intention-f-s)
       [set influence-out-ta 0
        set influence-out-sa 0
        set influence-out-tb 0
        set influence-out-sb 0
        set influence-out-tc 0
        set influence-out-sc 0
        set influence-out-td 0
        set influence-out-sd 0
        set influence-out-te 0
        set influence-out-se 0
        set influence-out-tf 0
        set influence-out-sf 100

        set a? false
        set b? false
        set c? false
        set d? false
        set e? false
        set f? true
        set smart-meter? true
        ]             
       ]                          
    ]
    
ask turtles with [smart-meter? = true]
    [set color yellow]
                                        
end

to do-plot
set-current-plot "SM market-share VS time-step"
set count-smart count turtles with [smart-meter? = true]
set-current-plot-pen "SM"
plot count-smart * 100 / (N * population-density)


set-current-plot "ES market-share VS time-step"
set count-a count turtles with [a? = true]
set count-b count turtles with [b? = true]
set count-c count turtles with [c? = true]
set count-d count turtles with [d? = true]
set count-e count turtles with [e? = true]
set count-f count turtles with [f? = true]
set-current-plot-pen "A"
plot count-a * 100 / (N * population-density)
set-current-plot-pen "B"
plot count-b * 100 / (N * population-density)
set-current-plot-pen "C"
plot count-c * 100 / (N * population-density)
set-current-plot-pen "D"
plot count-d * 100 / (N * population-density)
set-current-plot-pen "E"
plot count-e * 100 / (N * population-density)
set-current-plot-pen "F"
plot count-f * 100 / (N * population-density)


set-current-plot "Consumer Transfers"
set count-change count turtles with [change? = true]
set-current-plot-pen "A"
plot count-change 

end



@#$#@#$#@
GRAPHICS-WINDOW
725
10
3245
2551
125
125
10.0
1
10
1
1
1
0
1
1
1
-125
125
-125
125
0
0
1
ticks

CC-WINDOW
5
2565
3254
2660
Command Center
0

BUTTON
51
16
115
50
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
157
16
221
50
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
50
63
223
96
population-density
population-density
0
1
0.4
0.01
1
NIL
HORIZONTAL

SLIDER
52
109
224
142
radius
radius
0
10
4
1
1
NIL
HORIZONTAL

SLIDER
52
161
224
194
random-interaction
random-interaction
0
10
2
1
1
NIL
HORIZONTAL

PLOT
280
15
696
247
SM market-share VS time-step
time-step
SM market-share
0.0
24.0
0.0
100.0
true
false
PENS
"SM" 1.0 0 -1184463 true

PLOT
356
282
698
518
ES market-share VS time-step
time-step
ES market-share
0.0
24.0
0.0
100.0
true
false
PENS
"A" 1.0 0 -7500403 true
"B" 1.0 0 -2674135 true
"C" 1.0 0 -955883 true
"D" 1.0 0 -6459832 true
"E" 1.0 0 -1184463 true
"F" 1.0 0 -10899396 true

MONITOR
354
547
467
592
month
i
3
1
11

PLOT
10
281
319
518
Consumer Transfers
time-step
number of transfers
0.0
24.0
0.0
20000.0
true
false
PENS
"A" 1.0 0 -1184463 true

MONITOR
67
546
180
591
Market Share of A
count-a * 100 / (N * population-density)
3
1
11

MONITOR
69
610
181
655
Market Share of B
count-b * 100 / (N * population-density)
3
1
11

MONITOR
70
675
183
720
Market Share of C
count-c * 100 / (N * population-density)
3
1
11

MONITOR
204
546
317
591
Market Share of D
count-d * 100 / (N * population-density)
3
1
11

MONITOR
205
610
317
655
Market Share of E
count-e * 100 / (N * population-density)
3
1
11

MONITOR
205
674
317
719
Market Share of F
count-f * 100 / (N * population-density)
3
1
11

SLIDER
53
212
225
245
scenario
scenario
1
4
1
1
1
NIL
HORIZONTAL

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
